; ************************************************************************
; *                                                                      *
; *           Windows 32-bit Application Non-RTL Startup Code            *
; *                  Copyright (C) 2002, John Zaitseff                   *
; *                                                                      *
; ************************************************************************

; Author:    John Zaitseff <J.Zaitseff@zap.org.au>
; Date:      16th June, 2002
; Version:   1.0

; This file provides 32-bit Windows (Win32) applications with a minimalist
; start-up routine.  This start-up procedure calls the WinMain function but
; does little else.  In particular, this means that the Borland C++ Run-Time
; Library must NOT be used; neither can language features such as automatic
; Thread Local Storage (TLS), C/C++ exceptions, the default global variables
; nor the command line!

; This file is supplied as part of an application under the GNU General
; Public License.  Hence this file also falls under the same license.


            .386p
            model   flat

_TEXT       segment dword public use32 'CODE'

            extrn   WinMain:near
            extrn   GetModuleHandleA:near

            align   4

; ------------------------------------------------------------------------
; __acrtused: Start-up routine for non-RTL Win32 applications

; Note that the start-up routine MUST be called __acrtused, as that is what
; Microsoft expects (despite documentation to the contrary).

; This code does NOT initialise the BSS segment---do not assume global
; variables are initialised!  In addition, any DLLs are NOT initialised;
; this can cause subtle bugs if you are not careful.

            public  __acrtused
__acrtused  proc    near

; Get the instance handle of this module

            push    0
            call    GetModuleHandleA            ; result is in EAX

; Call WinMain.  This must have the following prototype:
;     int APIENTRY WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
;                           LPSTR lpCmdLine, int nShowCmd)

            push    10                          ; nShowCmd = SW_SHOWDEFAULT
            push    0                           ; lpCmdLine = NULL
            push    0                           ; hPrevInstance
            push    eax                         ; hInstance

            call    WinMain                     ; Call the C program
                                                ; Return code in EAX
            ret

            endp

            ends
            end     __acrtused
